<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="Content-type" content="text/html;charset=UTF-8" />
<title>Freghar's Gitlog - Rebase and remote</title>
</head>


<body>

<h1>Rebase and remote</h1>

&lt;snip&gt;

<p>Fast-forward merge is possible ONLY if one of the branches has no commits
ahead of the other. For example, if the original state would be</p>
<pre>
A - B                    (master)
     \
      - X - Y - Z        (testbranch)
</pre>
<p>testbranch can be fast-forwarded to master with following result:</p>
<pre>
A - B - X - Y - Z        (master)
</pre>
&lt;/snip&gt;

<p>Let's say that "master" here is your remote eventai and "local" is your local, rebased version.</p>
<pre>
A - B                    (master)

A - B - X - Y - Z        (local)
</pre>
<p>this is a valid case when you can push, because those branches have "common ancestor" = commit B</p>

<p>however when you have something like</p>
<pre>
A - B - X - Y - Z        (master)

A - B - C - X - Y - Z    (local)
</pre>
<p>Git may find out that B is the latest common ancestor, but it doesn't help. It's like any other push - you can rebase and do a classic push, but you will get conflicts due to applying X,Y,Z over to an already existing X,Y,Z.<br />
So there's no way (besides a recursive merge) how to do this the 100% safe way (ie. without force push) with keeping the whole thing clean.</p>

<p>You may ask "why it doesn't do the simple rebase itself on remote", there are three answers I can think of:</p>
<ol>
<li>remote repo is bare, only the .git/ directory with objects, it cannot merge, it just stores things.</li>
<li>there is a possibility of conflicts which would be really bad on a remote (for other people trying to push there)</li>
<li>as I said, commit hash uses also timestamp (this is not true for git-svn conversion though) so hashes would be different on remote = a LOT more problems than you really want</li>
</ol>

<p>So for these reasons, you need to either force push, use recursive merge or add reverting commits and then the original ones again.<br />
Simply saying you cannot transparently overwrite a commit on a remote without a force push.</p>

</body>


</html>
